#include "ti86asm.inc"
#include "rom86.h"


.org _asm_exec_ram

temp		= $8800
temp2		= _textShadow

seed		= temp		;2
tecken		= temp + 2	;1
mask		= temp + 3	;1
in_num		= temp + 4	;1
in_mask		= temp + 5	;1



Seed:              ;generate a new starting number
    call _random        ;0<=op1<1
    call _inco1exp      ;op1*10
    call _inco1exp      ;"      these 4 lines =op1*10,000
    call _inco1exp      ;"
    call _inco1exp      ;"
    call _INTGR         ;make op1 an integer
    call _convop1       ;conv op1 to de,a
    ld (seed),de        ;we want 2 bytes of random stuff
    ld b,3          ;set loop counter at 3
ShiftSeedLoop:
    ld hl,(seed)        ;this section shifts seed as a whole.
    sla h
    bit 7,l         ;test bit 7 of lower byte
    jr z,noinc
    inc h
noinc:
    sla l
    ld (seed),hl        ;end
    djnz ShiftSeedLoop 


start:
slump:
	call Random		; tar ett slumptal
	ld a,c
	and %00011111	;tar bort alla bitar strre n 32
;	inc a			;kar med ett
	cp 26			;ta nytt tal om det r strre n 20
	jp nc,slump

	ld hl,tecken
	cp (hl)
	jp z,slump
	ld (hl),a

clear:
	xor a
	ld (in_num),a
	ld (in_mask),a
	
	ld a,%10000000
	ld (mask),a

	call _homeup
	call _clrLCD


	ld a,(tecken)
	add a,'A'
	call _putc

	call _newline
	ld a,'?'
	call _putc

key_loop:
	call _getkey

	cp kExit
	jp z,sluta

	cp kChs
	jp z,in_streck
	cp kDecPnt	
	jp z,in_punkt

	cp kEnter
	jp z,enter

	cp kClear
	jp z,clear

	cp kDel	
	jp z,del

	jp key_loop

del:
	ld hl,in_num
	ld a,0
	cp (hl)
	jp z,key_loop
	dec (hl)

	ld hl,mask
	rlc (hl)

	ld a,(hl)
	cpl
	ld hl,in_mask
	and (hl)
	ld (hl),a

	ld hl,_curCol
	dec (hl)
	ld a,' '
	call _putmap
	jp key_loop




enter:
	ld a,(tecken)
	add a,a
	ld b,0
	ld c,a
	ld hl,morse
	add hl,bc

	ld a,(in_num)
	cp (hl)
	jp nz,fel

	ld a,(in_mask)
	inc hl
	cp (hl)
	jp nz,fel
	jp start

fel:
	call _newline
	ld a,'='
	call _putc

	ld a,(tecken)
	call conv
	call _getkey
	cp kExit
	jp z,sluta
	jp start


in_streck:
	ld a,'_'
	call _putc
	ld a,%11111111
	jp in_forts

in_punkt:
	ld a,'.'
	call _putc
	ld a,%00000000
;	jp in_forts	

in_forts:
	ld hl,mask
	and (hl)
	ld hl,in_mask
	or (hl)
	ld (hl),a

	ld hl,in_num
	inc (hl)

	ld hl,mask
	rrc (hl)
	jp key_loop



sluta:
	ret


conv:
	add a,a
	ld hl,morse
	ld b,0
	ld c,a
	add hl,bc

	ld b,(hl)
	inc hl
	ld c,(hl)
	ld d,%10000000
visa_loop:
	push bc
	ld a,c
	and d
	cp d
	jp z,streck
	ld a,'.'
	jp punkt
streck:
	ld a,'_'
punkt:
	push de
	call _putc
	pop de
	rrc	d
	pop bc
	djnz visa_loop
	ret


analy8:
	push af
	push bc
	push de
	push hl

	call _setXXop1
	ld a,3
	call _formReal
	ld hl,_OP3
	call _puts

	pop hl
	pop de
	pop bc
	pop af
	ret

Random:
;Random Number Generator by Steven Hunt.  For details
;on how this routine works, see random.txt
;Please give me credit if you use it.
    ld hl,(seed)    ;this section shifts seed as a whole.
    sla h
    bit 7,l     ;test if shifting LB would overflow
    jr z,noinc1 ;if not, don't inc UB
    inc h
noinc1:
    sla l
    ld (seed),hl ;end

;   ld a,h  ;higher byte->a
;	ld (randnum),a

	ld c,h			;c kommer inte att anvndas fre sluptalet behvs
	


testbit:            ;prepare new seed number (xor bit 14&15, store in bit 0)
    ld a,h          ;restore higher byte of seed
    and %01000000       ;mask all but bit 7 (15 of seed#)
    ld b,a          ;save result
    ld a,h
    sla a           ;shift higher byte left
    and %01000000       ;mask all but bit 7 (14 of seed# after shift)
    xor b           ;see if bits 15&14 are =
    jp z,resbit     ;test result of xor
    ld hl,seed
    set 0,(hl)      ;they were different, so set bit 0 of seed
    ret
resbit:             ;they were the same, so reset bit 0 of seed
    ld hl,seed
    res 0,(hl)
    ret 



morse:
	.db 2,%01000000		;a
	.db 4,%10000000		;b
	.db 4,%10100000		;c
	.db 3,%10000000		;d
	.db 1,%00000000		;e
	.db 4,%00100000		;f
	.db 3,%11000000		;g
	.db 4,%00000000		;h
	.db 2,%00000000		;i
	.db 4,%01110000		;j
	.db 3,%10100000		;k
	.db 4,%01000000		;l
	.db 2,%11000000		;m
	.db 2,%10000000		;n
	.db 3,%11100000		;o
	.db 4,%01100000		;p
	.db 4,%11010000		;q
	.db 3,%01000000		;r
	.db 3,%00000000		;s
	.db 1,%10000000		;t
	.db 3,%00100000		;u
	.db 4,%00010000		;v
	.db	3,%01100000		;w
	.db 4,%10010000		;x
	.db 4,%10110000		;y
	.db 4,%11000000		;z

.end